﻿---------------------------------------------------------
--	ARKadium's Undaunted Core file    	   				-
--	Written by @Carter_DC (EU) / coirier.rom1@gmail.com -
--------------------------------------------------------- 
-- TODO : Update trackker on dungeon enters, optionnal dungeon timer, monster item links,
--        detect hardmode completed, welcome screen, titleoverride (RaidNotifier)
--		  prefered mode normal, vet, vet hm with alerts
--		précocher les case en recherche de donj !!!


---------------------------------------------------------
--	LOCALS & DEFAULTS		   	   					   --
--------------------------------------------------------- 

ARK_Undaunted      = ARK_Undaunted or {}
local UDT = ARK_Undaunted

UDT.AddonName        	= "ARK_Undaunted"
UDT.AddonVersion    	= "1.8"

UDT.author 				= "Carter_DC"
UDT.SavedVarsVersion 	= "1.5"
UDT.GuildName 		 	= "ARKADIUM"
UDT.GuildWebSite 		= "http://www.esoui.com"

UDT.defaults  = {-- default settings for saved variables

    --general
	bUseDebugMode 		= false,
	bEnableStartMessage = false,
	--permissions
	bIsTester			= false, 
	
	MainTextColor		={
		r 				= 0.8, --204
		g 				= 0.04, --10
		b 				= 0,
		a 				= 1, --255
		hex 			= "CC0A00",
	},

     --dailies
	 bAdvertizeDailies = true, 
	 bDisplayLootLink = true,
	 bAutoDelete    = false,
	 bDisplayChestHelper = true,
	 bQuickDialog = true,
	 bEnableLFG = false,
	 
	-- pledgePreferedMode = PLEDGE_MODE_HM,
	-- lfgText = "{Level} {Role} lfg {Quest Name} {Mode}", --{Level} {Role} lfg pledges (no DLC) {Mode}
	 	
}

local WM = WINDOW_MANAGER

local ORIGIN_TIMESTAMP = 1502690400 --08/14/2017 @ 6:00am (UTC)
local UNDAUNTED_KEY_ITEM_INDEX = 55448 -- eso item index for an undaunted key 

local MAJ      = 1
local GLIRION  = 2
local URGARLAG = 3


local QUEST_CAT_ZONE  = 1  
local QUEST_CAT_OTHER = 2
local QUEST_CAT_MISC  = 3
local QUEST_CAT_UNDAUNTED_PLEDGE = 4 --Added this quest category

local PLEDGE_MODE_NORMAL = 1
local PLEDGE_MODE_VET = 2
local PLEDGE_MODE_HM = 3

local pledgeModes = {
	[PLEDGE_MODE_NORMAL] = "Normal Mode",
	[PLEDGE_MODE_VET] = "Veteran Mode",
	[PLEDGE_MODE_HM] = "Vet HM",
}

UDT.sVars={}
local UDT_UI
local TodaysDailies = {}
-- colors
local BLUE, RED, WHITE = 1,2,3

---------------------------------------------------------
--	EVENT HANDLERS			   	   					   --
--------------------------------------------------------- 

function UDT.OnAddOnLoaded( eventCode, name )

	if name ~= UDT.AddonName then return end
	
	EVENT_MANAGER:UnregisterForEvent( UDT.AddonName, EVENT_ADD_ON_LOADED )
	--initialize, only, once the player is activated
	EVENT_MANAGER:RegisterForEvent( UDT.AddonName, EVENT_PLAYER_ACTIVATED , UDT.Initialize )
		
end

--called once, the first time the player finsishes loading an area (new zone or reloadui or tp in same zone)
function UDT.Initialize() -- == player activated

	--loads saved variables from file or default
	UDT.sVars = ZO_SavedVars:New( "ARK_UDT_SavedVariables", UDT.SavedVarsVersion, nil, UDT.defaults )
	
	EVENT_MANAGER:UnregisterForEvent( UDT.AddonName, EVENT_PLAYER_ACTIVATED )
	
	--permissions
	if ( not UDT.CheckPermissions() ) then return end --player doesn't have the permission to use the addon
	
	--init-- 
	ZO_PreHook(_G, "ZO_QuestJournalNavigationEntry_OnMouseUp", UDT.QuestContextMenu)
	if UDT.sVars.bDisplayChestHelper then
		ZO_PreHook(RETICLE, "TryHandlingInteraction", UDT.TryHandlingInteraction)
	end
	if UDT.sVars.bQuickDialog then
		EVENT_MANAGER:RegisterForEvent(UDT.AddonName, EVENT_CHATTER_BEGIN, UDT.OnChatterBegin)
	end
	
	UDT.InitUI()		
			
	zo_callLater(function() UDT.InitDailesManagement() end, 3000)
	
  	-- Settings Module
	UDT.CreateSettingsMenu()

	EVENT_MANAGER:RegisterForEvent(UDT.AddonName, EVENT_RETICLE_HIDDEN_UPDATE, UDT.OnReticleHiddenUpdate)
	EVENT_MANAGER:RegisterForEvent(UDT.AddonName, EVENT_GUILD_SELF_JOINED_GUILD , UDT.OnPlayerJoindedGuild )
	EVENT_MANAGER:RegisterForEvent(UDT.AddonName, EVENT_GUILD_SELF_LEFT_GUILD , UDT.OnPlayerLeftGuild )
end

--redo the guild list if player joins or leaves a guild.
function UDT.OnPlayerJoindedGuild ( eventCode, guildId, guildName)
	UDT.CheckPermissions()
end

function UDT.OnPlayerLeftGuild( eventCode, guildId, guildName)
	UDT.CheckPermissions()
end

--event :  ensure ui is hidden when reticle is also hidden
function UDT.OnReticleHiddenUpdate(eventCode, hidden)
	if hidden then UDT_UI:SetHidden(true) end
end

--event : triggered when discussion begins (with item or npc)
--start of quick dialog functions
--Quest offering dialog has 3 prompts
--first one is dealt with slect chatter option in 'chatter begin"
--second one, is dealt with Accept offered quest in "pseudoConversationUpdated" (should be a select chatter option in a conversation updated event)
--Last one is dealt with a AcceptOfferedQuest in OnQuestOffered
function UDT.OnChatterBegin(eventCode, optionCount)
	 
	local optionString, _ = GetChatterOption(1)
	if optionString == "" then return end --happens when only option is "goodbye"
	
	--only executes if "interact" is an undaunted quest giver
	local unitName = GetRawUnitName('interact')
	if string.find(unitName, GetString(ARK_UDT_URGARLAG)) or string.find(unitName, GetString(ARK_UDT_GLIRION)) or string.find(unitName, GetString(ARK_UDT_MAJ)) then
		
		if string.find(string.upper(optionString), GetString(ARK_UDT_PLEDGE)) then
			--dialog is pledge offering
			EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_QUEST_OFFERED, UDT.PseudoOnConversationUpdated) -- event should be onconvupdated but strangely is quest offered 
			SelectChatterOption(1)
		else
			--dialog is pledge return
			EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_CONVERSATION_UPDATED, UDT.OnConversationUpdated)
			SelectChatterOption(1)
		end
	end
end

-- event : should be conversation updated but is in fact quest_offered event
function UDT.PseudoOnConversationUpdated(eventCode) 
	EVENT_MANAGER:UnregisterForEvent(ADDON_NAME, EVENT_QUEST_OFFERED)
	EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_QUEST_OFFERED, UDT.OnQuestOffered)
	AcceptOfferedQuest()
end

-- event : last line of dialog => accepts quest
function UDT.OnQuestOffered(eventCode)
	EVENT_MANAGER:UnregisterForEvent(ADDON_NAME, EVENT_QUEST_OFFERED)	
	AcceptOfferedQuest()
end

-- event, last line of dialog before actually returning the quest
function UDT.OnConversationUpdated(eventCode, conversationBodyText, conversationOptionCount)
	
	EVENT_MANAGER:UnregisterForEvent(ADDON_NAME, EVENT_CONVERSATION_UPDATED)
	EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_QUEST_COMPLETE_DIALOG, UDT.OnQuestCompleteDialog)
	SelectChatterOption(1)
end

-- event : complete the quests and get the loots. (no error management if inventory is full)
function UDT.OnQuestCompleteDialog(eventCode)
	EVENT_MANAGER:UnregisterForEvent(ADDON_NAME, EVENT_QUEST_COMPLETE_DIALOG)
	CompleteQuest()	
end



---------------------------------------------------------
--	HOOKS & OVERRIDES		   	   					   --
--------------------------------------------------------- 


--prehook for reticle function
--displays the ui containing all setsd names when hovering a reward chest
function UDT.TryHandlingInteraction(interactionPossible)
	if not UDT.sVars.bDisplayChestHelper then return false end
		if interactionPossible then
			local _, name, _, _, _, _, contextualLink, _ = GetGameCameraInteractableActionInfo()
			if contextualLink ~= nil and contextualLink ~= "" then
				if string.find(contextualLink, UNDAUNTED_KEY_ITEM_INDEX) then
					--UDT.Debug("TryHandlingInteraction","Function")
					ARK_UDT_CHEST_HELPER_LABEL1:SetText(GetString(ARK_UDT_MAY_CONTAIN))
					if string.find(name, GetString(ARK_UDT_MAJ)) then
						ARK_UDT_CHEST_HELPER_LABEL2:SetText(GetString(ARK_UDT_CHEST_MAJ))
					end 
					if string.find(name, GetString(ARK_UDT_GLIRION)) then
						ARK_UDT_CHEST_HELPER_LABEL2:SetText(GetString(ARK_UDT_CHEST_GLIRION))
					end 
					if string.find(name, GetString(ARK_UDT_URGARLAG)) then
						ARK_UDT_CHEST_HELPER_LABEL2:SetText(GetString(ARK_UDT_CHEST_URGARLAG))
					end 
			
					UDT_UI:SetHidden(false)
					
				else -- ARK_UDT_REWARD_CHEST not found in interactable name
					UDT_UI:SetHidden(true)
				end
			else -- interactable name is ""
				UDT_UI:SetHidden(true)			
			end
		else 
			UDT_UI:SetHidden(true)
		end
	return false -- always perform original RETICLE:TryHandlingInteraction after prehook
end

--prehook for ZO_QuestJournalNavigationEntry_OnMouseUp
--adds multiple entries in the context menu for undaunted quests
function UDT.QuestContextMenu(label, button, upInside) --ZO_QuestJournalNavigationEntry_OnMouseUp(label, button, upInside)
    if(button == MOUSE_BUTTON_INDEX_RIGHT and upInside) then
		local node = label.node
        local questIndex = node.data.questIndex
        if UDT.isPledge(questIndex) then
            ClearMenu()
			--add teleport option
			AddMenuItem(GetString(ARK_UDT_TELEPORT), function() UDT.Teleport(questIndex) end)
			--todo, add join queue
			
            AddMenuItem(GetString(SI_QUEST_JOURNAL_SHOW_ON_MAP), function() ZO_WorldMap_ShowQuestOnMap(questIndex) end)
            if GetIsQuestSharable(questIndex) and IsUnitGrouped("player") then
                AddMenuItem(GetString(SI_QUEST_JOURNAL_SHARE), function() QUEST_JOURNAL_MANAGER:ShareQuest(questIndex) end)
            end
            if(node.data.questType ~= QUEST_TYPE_MAIN_STORY) then
                AddMenuItem(GetString(SI_QUEST_JOURNAL_ABANDON), function() QUEST_JOURNAL_MANAGER:ConfirmAbandonQuest(questIndex) end)
            end

            AddMenuItem(GetString(SI_QUEST_JOURNAL_REPORT_QUEST), function() 
																	HELP_CUSTOMER_SUPPORT_KEYBOARD:OpenScreen(HELP_CUSTOMER_SERVICE_ASK_FOR_HELP_KEYBOARD_FRAGMENT)
																	HELP_CUSTOMER_SERVICE_ASK_FOR_HELP_KEYBOARD:SetDetailsFromQuestName(node.data.name)
																end)

            ShowMenu(label)
			return true
        else
			return false
		end
	else 
		return false --
	end
end

--override 
--adds new category for undaunted quests in journal
function ZO_QuestJournal_Manager:GetQuestListData()
	local seenCategories = {}
    local categories = {}
    local quests = {}
    -- Create a table for categories and one for quests
    for i = 1, MAX_JOURNAL_QUESTS do
        if IsValidQuestIndex(i) then  
            local zone = GetJournalQuestLocationInfo(i)
            local questType = GetJournalQuestType(i)
            local name = GetJournalQuestName(i)
            local level = GetJournalQuestLevel(i)
            local instanceDisplayType = GetJournalQuestInstanceDisplayType(i)
            local categoryName
            local type
            if questType == QUEST_TYPE_MAIN_STORY then
                categoryName = GetString("SI_QUESTTYPE", QUEST_TYPE_MAIN_STORY)
                type = QUEST_CAT_OTHER
            elseif questType == QUEST_TYPE_GUILD then
                categoryName = GetString("SI_QUESTTYPE", QUEST_TYPE_GUILD)
                type = QUEST_CAT_OTHER
            elseif questType == QUEST_TYPE_CRAFTING then
                categoryName = GetString("SI_QUESTTYPE", QUEST_TYPE_CRAFTING)
                type = QUEST_CAT_OTHER
            elseif questType == QUEST_TYPE_HOLIDAY_EVENT then
                categoryName = GetString("SI_QUESTTYPE", QUEST_TYPE_HOLIDAY_EVENT)
                type= QUEST_CAT_OTHER
            elseif questType == QUEST_TYPE_BATTLEGROUND then
                categoryName = GetString("SI_QUESTTYPE", QUEST_TYPE_BATTLEGROUND)
                type = QUEST_CAT_OTHER
            elseif zone ~= "" then
				--quest should be in "zone" category
				if UDT.isPledge(i) then
					--quest is undaunted pledge => add it in new category 
				    categoryName = GetString(ARK_UDT_PLEDGE_CATEGORY)
					type = QUEST_CAT_UNDAUNTED_PLEDGE				
				else
				    categoryName = zo_strformat(SI_QUEST_JOURNAL_ZONE_FORMAT, zone)
					type = QUEST_CAT_ZONE
				end				
            else
                categoryName = GetString(SI_QUEST_JOURNAL_GENERAL_CATEGORY)
                type = QUEST_CAT_MISC
            end
            if not seenCategories[categoryName] then
                table.insert(categories, {name = categoryName, type = type})
                seenCategories[categoryName] = true
            end
            if name == "" then
                name = GetString(SI_QUEST_JOURNAL_UNKNOWN_QUEST_NAME)
            end
            table.insert(quests,
                {
                    name = name,
                    questIndex = i,
                    level = level,
                    questType = questType,
                    categoryName = categoryName,
                    categoryType = type,
                    questType = questType,
                    displayType = instanceDisplayType
                }
            )
        end
    end
    -- Sort the tables
    table.sort(categories, UDT.SortQuestCategories)
    table.sort(quests, UDT.SortQuestEntries)
    return quests, categories, seenCategories
end

---------------------------------------------------------
--	DAILIES MANAGEMENT		   	   					   --
--------------------------------------------------------- 

-- force the refresh of quest list on init dailies
function UDT.ForceRefreshQuestMasterList()
    local quests, categories, seenCategories = ZO_QuestJournal_Manager:GetQuestListData()
	local questJournalObject = SYSTEMS:GetObject("questJournal")
    questJournalObject.questMasterList = {
        quests = quests,
        categories = categories,
        seenCategories = seenCategories,
    }
	return true
end

-- force the refresh of quest list on init dailies
function UDT.ForceRefreshQuestList()
    local questJournalObject = SYSTEMS:GetObject("questJournal")
    local quests = questJournalObject.questMasterList.quests
    local categories = questJournalObject.questMasterList.categories

    questJournalObject.questIndexToTreeNode = {}

    ClearTooltip(InformationTooltip)

    -- Add items to the tree
    questJournalObject.navigationTree:Reset()

    local categoryNodes = {}

    for i = 1, #categories do
        local categoryInfo = categories[i]
        categoryNodes[categoryInfo.name] = questJournalObject.navigationTree:AddNode("ZO_QuestJournalHeader", categoryInfo.name, nil, SOUNDS.QUEST_BLADE_SELECTED)
    end

    local firstNode
    local lastNode
    for i = 1, #quests do
        local questInfo = quests[i]
        local parent = categoryNodes[questInfo.categoryName]
        local questNode = questJournalObject.navigationTree:AddNode("ZO_QuestJournalNavigationEntry", questInfo, parent, SOUNDS.QUEST_SELECTED)
        firstNode = firstNode or questNode
        questJournalObject.questIndexToTreeNode[questInfo.questIndex] = questNode

        if lastNode then
            lastNode.nextNode = questNode
        end

        if i == #quests then
            questNode.nextNode = firstNode
        end

        lastNode = questNode
    end

    questJournalObject.navigationTree:Commit()

    questJournalObject:RefreshDetails()

    questJournalObject.listDirty = false
	
	return true
end

--populates dailies array, force the refresh of quest list if no quest have been removed
--
function UDT.InitDailesManagement()
	
	local secondsTillNextDailies = UDT.PopulateDailies()
	if UDT.sVars.bAutoDelete then
		local bAbandonned = UDT.DeleteNonCompletedDailies() 
		if not bAbandonned then
			UDT.ForceRefreshQuestMasterList()
			UDT.ForceRefreshQuestList()		
		end
	else
		UDT.ForceRefreshQuestMasterList()
		UDT.ForceRefreshQuestList()		
	end
	
	if UDT.sVars.bAdvertizeDailies then
		UDT.DisplayDailies()
	end
	
	zo_callLater(function() UDT.RefreshDailies() end, secondsTillNextDailies*1000)	
end

--questindex is pledge if type dungeon and name contains localized version of the word "PLEDGE" 
function UDT.isPledge(questIndex)
	if GetJournalQuestType(questIndex) ~= QUEST_TYPE_DUNGEON then return false end
	if string.find(string.upper(GetJournalQuestName(questIndex)), GetString(ARK_UDT_PLEDGE)) then return true end
	return false
end

--populates the dailies array given the current timestamp, the origin timestamp and the tables in ark_undaunted_data
function UDT.PopulateDailies()
	local secondsSinceStart = GetTimeStamp() - ORIGIN_TIMESTAMP
	local daysElapsed, dayFraction = math.modf((secondsSinceStart)/86400)
	local secondsTillNextDailies = 86400 - (dayFraction * 86400)
		
	-- Maj and Glirion cycle through 12 dailies
	local cyclesCount, cycleFraction = math.modf(daysElapsed/12)
	local daysSinceCycleStart = UDT.Round(cycleFraction*12)--rounds the value to nearest integer
	
	TodaysDailies[MAJ] = UDT.GetLocalizedPledge(daysSinceCycleStart,MAJ)
	TodaysDailies[GLIRION] = UDT.GetLocalizedPledge(daysSinceCycleStart,GLIRION)

	--Urgarlag cycles through 10 pleges
	cyclesCount,cycleFraction = math.modf(daysElapsed/10)
	daysSinceCycleStart = UDT.Round(cycleFraction *10)
	TodaysDailies[URGARLAG] = UDT.GetLocalizedPledge(daysSinceCycleStart,URGARLAG)
	
	return secondsTillNextDailies --returns second till next dailies cycle (6am utc) 
end

--advertizes dailies in chat 
function UDT.DisplayDailies()
	
	UDT.Msg2Chat(UDT.Colorize(GetString(ARK_UDT_UNDAUNTED_DAILES), WHITE))
	--todo : add link to monster sets helm	
	UDT.DisplayDailie(GetString(ARK_UDT_FROM_MAJ), TodaysDailies[MAJ].Regular)
	UDT.DisplayDailie(GetString(ARK_UDT_FROM_GLIRION), TodaysDailies[GLIRION].Regular)
	UDT.DisplayDailie(GetString(ARK_UDT_FROM_URGARLAG), TodaysDailies[URGARLAG].Regular)

end

--creates and displays text for a specific dailie
function UDT.DisplayDailie(fromString, dungeonString)
	
	UDT.Msg2Chat(UDT.Colorize(fromString, WHITE))
	UDT.Msg2Chat("|t15:15:esoui/art/tutorial/smithing_rightarrow_up.dds|t"..UDT.Colorize(dungeonString))	

end


--called if player is still online when the new dailies are up
function UDT.RefreshDailies()
	--todo, replace with center screen message
	UDT.Msg2Chat(GetString(ARK_UDT_NEW_DAILIES), WHITE)
	UDT.InitDailesManagement()
end

--only way to know if a dailie has been completed is to check in the text for "return to..." or "talk to..."
--since player might have completed dailies before installing the addon
function UDT.IsQuestComplete(questIndex)
	local _, _, _, _, activeStepTrackerOverrideText, _, _, _, _,_ = GetJournalQuestInfo(questIndex)
	if activeStepTrackerOverrideText == "" then return false end
	if string.find(activeStepTrackerOverrideText, GetString("ARK_UDT_QUEST_COMPLETE_1")) then
		return true
	elseif string.find(activeStepTrackerOverrideText, GetString("ARK_UDT_QUEST_COMPLETE_2")) then
		return true
	end
	return false  
end

--check for questname in the dailies array
function UDT.IsTodaysQuest(questIndex)
	local questName = string.upper(GetJournalQuestName(questIndex))
	--UDT.Debug("IsTodaysQuest", "Function")
	
	if (questName == string.upper(TodaysDailies[MAJ].Quest)) or (questName == string.upper(TodaysDailies[GLIRION].Quest)) or (questName == string.upper(TodaysDailies[URGARLAG].Quest)) then
		return true
	end
	
	UDT.sVars.testage = GetJournalQuestName(questIndex)	
	return false
end

--only abandon a quest if it's not complete AND not todays quest
--returns true if any quest has been abandonned
function UDT.DeleteNonCompletedDailies()
	local bAbandonned
	for questIndex = 1, MAX_JOURNAL_QUESTS do
		if UDT.isPledge(questIndex) then
			if not UDT.IsTodaysQuest(questIndex) and not UDT.IsQuestComplete(questIndex) then
				bAbandonned = true
				UDT.Msg2Chat(UDT.Colorize(GetJournalQuestName(questIndex).." "..GetString(ARK_UDT_ABANDONNED)))
				AbandonQuest(questIndex)
			end
		end
	end	
	return bAbandonned
end

--override from original local quest categories sorting (no actual changes)
function UDT.SortQuestCategories(entry1, entry2)
    if entry1.type == entry2.type then
        return entry1.name < entry2.name
    else
        return entry1.type < entry2.type
    end
end

--override from original local quest categories sorting (no actual changes)
function UDT.SortQuestEntries(entry1, entry2)
	--todo : always add dlc quest in last position
    if entry1.categoryType == entry2.categoryType then
        if entry1.categoryName == entry2.categoryName then
            return entry1.name < entry2.name
        end

        return entry1.categoryName < entry2.categoryName
    end
    return entry1.categoryType < entry2.categoryType
end

--teleports player to quest node (defined in localisation file)
function UDT.Teleport(questIndex)
	--todo : auto teleport for free if group member already in the instance
	local data ={}
	local questName = GetJournalQuestName(questIndex)
	for _, pledge in pairs(localizedPledges) do
		if questName == pledge.Quest then
			data.node = pledge.Node
			data.pledgeName = pledge.Regular
		end
	end	
	if not IsGroupUsingVeteranDifficulty() then
		--warns player if group is not in vet mode
		ZO_Dialogs_ShowDialog("ARK_UDT_TELEPORT", {data.node,data.pledgeName,}, {titleParams={data.pledgeName},}, false)
	else
		FastTravelToNode(data.node)
		UDT.Msg2Chat(UDT.Colorize(GetString(ARK_UDT_TELEPORTING_TO)..data.pledgeName..GetString(ARK_UDT_HAS_COST_YOU), WHITE)..UDT.Colorize(GetRecallCost(194), RED)..UDT.Colorize(GetString(ARK_UDT_GOLD), WHITE))
	end		
	
end

function UDT.GetDailiesTooltipText()
	local ttText = GetString(ARK_UDT_BUTTON_TT).."\r\n"..UDT.Colorize(GetString(ARK_UDT_PLEDGE_CATEGORY)).." :\r\n"
	ttText = ttText.."|t15:15:esoui/art/tutorial/smithing_rightarrow_up.dds|t"..TodaysDailies[MAJ].Regular.."\r\n"
	ttText = ttText.."|t15:15:esoui/art/tutorial/smithing_rightarrow_up.dds|t"..TodaysDailies[GLIRION].Regular.."\r\n"
	ttText = ttText.."|t15:15:esoui/art/tutorial/smithing_rightarrow_up.dds|t"..TodaysDailies[URGARLAG].Regular
	return ttText	
end

function UDT.DailiesInChat()

	local myText = "[ARKadium's Undaunted] : " 
	myText = myText..TodaysDailies[MAJ].Regular..", "
	myText = myText..TodaysDailies[GLIRION].Regular..", "
	myText = myText..TodaysDailies[URGARLAG].Regular.."."
	
	CHAT_SYSTEM.textEntry:SetText(myText)
	CHAT_SYSTEM:Maximize()
	CHAT_SYSTEM.textEntry:Open()
		
end

function UDT.StartMessage()
	UDT.displayName = UDT.Colorize( "ARKadium" )..UDT.Colorize( "'s Undaunted.", WHITE )
	--writes addon's advert in chat
	zo_callLater(function() UDT.Msg2Chat(UDT.displayName..UDT.Colorize( " v "..UDT.AddonVersion, WHITE )) end, 2000)
	zo_callLater(function() UDT.Debug( UDT.sVars.bUseDebugMode, "Debug Mode" ) end, 2500)
end

---------------------------------------------------------
--	UTILS					   	   					   --
--------------------------------------------------------- 

function UDT.PopulateGuildList()
	UDT.guildList = {}
	
	for guildId =1, 5, 1 do
      if GetGuildName(guildId) == "" then break end   
      UDT.guildList[GetGuildName(guildId)] = guildId            
    end 
end

function UDT.CheckPermissions()
	
	UDT.PopulateGuildList()
	local permissionGranted = true
	
	for i, guildName in ipairs (UDT.guildList) do
		if ( string.upper(guildName) == UDT.GuildName ) then 
			UDT.sVars.bIsTester = true
		end	
	end

	--todo : set permissionGranted to false under smoe circumpstances
	return permissionGranted
	
end

--round to nearest
function UDT.Round( val, decimal )
	if ( decimal ) then
		return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
	else
		return math.floor(val+0.5)
	end
end

function UDT.Colorize( stringToColorize, color )
	
	if ( color ~= nil and color ~="" ) then 
		if color == BLUE then
			return "|c2020F0"..stringToColorize.."|r"
		elseif color == WHITE then
			return "|cF0F0F0"..stringToColorize.."|r"
		elseif color == RED then
			return "|cF02020"..stringToColorize.."|r"
		end		
	else
		return "|c"..UDT.sVars.MainTextColor.hex..""..stringToColorize.."|r"	
	end
	
end

	
function UDT.Debug( paramToDump, paramName )

	if UDT.sVars.bUseDebugMode then
		
		if ( paramToDump == nil ) then
			paramToDump = UDT.Colorize( "Null value", RED ) 
		elseif ( paramToDump == "" ) then
			paramToDump = UDT.Colorize( "Empty string", RED ) 
		elseif ( paramToDump == true ) then 
			paramToDump = UDT.Colorize( "True", BLUE )
		elseif ( paramToDump == false ) then
			paramToDump = UDT.Colorize( "False", BLUE )
		else
			paramToDump = UDT.Colorize( paramToDump, WHITE ) 
		end
	
		if ( paramName == nil ) or ( paramName == "" ) then 
			paramName = UDT.Colorize( "Debug out", WHITE ) 
		elseif ( string.find("Function, Event, Override, PreHook, Binding, Slash, Module Loaded", paramName ) ) then 
			paramName = UDT.Colorize( paramName, BLUE )
		else
			paramName = UDT.Colorize( paramName, WHITE )
		end

		UDT.Msg2Chat( paramName.." : "..paramToDump)
	end
end

function UDT.Msg2Chat( stringToDisplay )
	d(stringToDisplay)
end

function UDT.Test()
	UDT.Debug("Test","Function")
	
 	
	--for internalIndex = 0, 5 do
	--		CHAT_SYSTEM["containers"][1]["currentBuffer"]:AddMessage(internalIndex.." : "..UDT.GetPledgeLink(internalIndex,URGARLAG))
	--end
	
	--gets the list of dungeons nodes
	--for nodeIndex = 1, GetNumFastTravelNodes() do
	--	local _, nodeName, _, _, _, _, _, _, _ = GetFastTravelNodeInfo(nodeIndex)
	--	if string.find(nodeName, "Donjon") then
	--		UDT.Debug (nodeIndex, nodeName)
	--	end
	--end	
end

--for debug purposes only
function UDT.DumpQuestInfo(questIndex)

	local questName, backgroundText, activeStepText, activeStepType, activeStepTrackerOverrideText, completed, tracked, questLevel, pushed, questType, instanceDisplayType = GetJournalQuestInfo(questIndex)
	UDT.Debug (questIndex,"questIndex")
	UDT.Debug (questName,"questName")
	UDT.Debug (backgroundText,"backgroundText")
	UDT.Debug (activeStepText,"activeStepText")
	UDT.Debug (activeStepType,"activeStepType")
	UDT.Debug (activeStepTrackerOverrideText,"activeStepTrackerOverrideText")
	UDT.Debug (completed,"completed")
	UDT.Debug (tracked,"tracked")
	UDT.Debug (questLevel,"questLevel")
	UDT.Debug (pushed,"pushed")
	UDT.Debug (questType,"questType")
	UDT.Debug (instanceDisplayType,"instanceDisplayType")

end

--[[***********************************************************************************************************
*************************************             UI MANAGEMENT           *************************************
*************************************                                     *************************************
*************************************************************************************************************]] 
--"/esoui/art/actionbar/passiveabilityframe_round_up.dds"


function UDT.InitUI()
	UDT_UI = WINDOW_MANAGER:GetControlByName("ARK_UDT_CHEST_HELPER")
	
	local button = WINDOW_MANAGER:GetControlByName("ARK_UDT_Button_Button")
	button:SetHandler("OnClicked", function(self) UDT.DailiesInChat() end)
	button:SetHandler("OnMouseEnter", function(self) UDT.DisplayTooltip(self) end)
    button:SetHandler("OnMouseExit", function(self) ZO_Tooltips_HideTextTooltip() end)   
	
	local tlc =  WINDOW_MANAGER:GetControlByName("ARK_UDT_Button")
	local fragment = ZO_SimpleSceneFragment:New(tlc)
	QUEST_JOURNAL_SCENE:AddFragment(fragment)
 
 end

 function UDT.DisplayTooltip(ctrl)
 
    ZO_Tooltips_ShowTextTooltip(ctrl, TOP, UDT.GetDailiesTooltipText())
    
end


SLASH_COMMANDS["/testage"] = UDT.Test
EVENT_MANAGER:RegisterForEvent(UDT.AddonName, EVENT_ADD_ON_LOADED, UDT.OnAddOnLoaded)
